Status: Rejected Start date: September 10, 2016

Priority: Minor Due date:  

Assignee:  % Done: 0%

Category:  Estimated time: 0.00 hour

Target version:    

Affects version: 3.7.2   

Description

Audacious 3.7.2 seems to display wrong track lengths for some songs. However, it does read them to the end, leading to weird times

like 16:00/3:51. In comparison, VLC shows the correct track length.

Attached is a screenshot of the issue. Here is a link to one of the songs that cause the issue for me (it's too big to upload here) : 

https://mega.nz/#!cskBgLTb!9Sh1lJaNyfzE_GuRnUtZsl-s_36pKmkMZod9v7rEs9Q

History

#1 - September 10, 2016 18:42 - John Lindgren

- Status changed from New to Rejected

Not a bug.  Most MP3 files do not include accurate length information, so the value displayed is a guess.  Enable the "Use accurate length calculation

(slow)" option in the MPG123 plugin settings if you can live with the performance penalty.

#2 - September 10, 2016 18:57 - Not My Real Name

John Lindgren wrote:

Not a bug.  Most MP3 files do not include accurate length information, so the value displayed is a guess.  Enable the "Use accurate length

calculation (slow)" option in the MPG123 plugin settings if you can live with the performance penalty.

 

I see, thank you, that fixed it. If you don't want to enable the more accurate version by default, an option would be to check the time length before

playing the song. That way you don't have to check all songs that could be added at once. Audacity remains fast while still being more accurate than

now.

That would at least avoid strange sightings like the one I mentioned in my first post. Your call, though.

#3 - September 11, 2016 07:03 - John Lindgren

Unfortunately there's no good solution that will please everyone.  If you're playing a file that's stored locally on a solid-state drive, then it's fine to read

in the entire file to compute an accurate length before starting playback.  But if we make that the default, then we'll get a bug report from someone

playing files over a slow network link, because now there is a delay before his song starts to play.

The only real way to solve the problem is on the encoder side.  If MP3 encoders would just set the length field in the ID3 tag correctly, then the length

could be displayed both quickly and accurately.  But MP3 encoders in the wild are a real mess; most don't set the length field at all, and others have

been known to set it to a completely wrong value such as zero (we have a sanity check in Audacious now to detect that).
#4 - September 11, 2016 11:18 - Not My Real Name

I see, interesting that the length tag wouldn't always be set correctly, even if it's one of the most important tags. Well, thank you for answering,

anyways !

#5 - May 22, 2021 09:17 - Philipp Philipp

I think it's important to distinguish between the displayed track length (of any track in the plyalist) and the length of the track currently being played.

The latter isn't just displayed, but it also affects the scrubber: If the true track is longer, it's impossible to seek to certain positions. If the true track is

shorter, seeking past the true end will suddenly abort the playback.

Unfortunately there's no good solution that will please everyone.

 

How do other players do it? mpv, Celluloid, Rhythmbox and VLC all display the correct length. Does that imply that they would be slow to open a file

from a slow (network) drive? Or have they found some other solution? Maybe they have a better guessing algorithm?

There are compromise solutions that would work well for everyone, they just might be difficult to implement. For instance, the guessed time could be

played initially, but while the track is already playing, Audacious could run the slower and more accurate guess in the background and update the

display and scrubber as soon as the accurate length is available.
